#ifndef _Implicit_h
  #define _Implicit_h

  #include "Mesh.h"
  #include "Types.h"
  #include "Solver.h"
  #include "Matrix.h"

/*  uint index2element(uint ,uint ,uint ); */
/*  void element2index(uint ,uint* ,uint* ,uint* );*/

int Threem (matrix4 ,double4 ,matrix4 ,matrix4 );
int Matrixpm(double4 ,double ,double2 , double, matrix4 ,matrix4 ,
	    double , double, double);
int Matrix_Times_Vector44(matrix4 ,double4 , double4 );
int Set_Slip(tSolver_State *,uint , uint , uint , double ,double4, double4, double24  )
int Transform_w2q(double4 , double2 , double , double4 , double4 )
int Transform_q2w(double4 , double2 , double , double4 , double4 )
#endif
